---------------
-- rm area_street_intersects.db ; spatialite area_street_intersects.db < build.area_street_intersects.sql;
---------------
SELECT DateTime('now'),'build.area_street_intersects.sql [start] ';
---------------------------
SELECT DateTime('now'),'ATTACH DATABASE ''area_bernauer_strasse.db'' AS db_import';
ATTACH DATABASE 'area_bernauer_strasse.db' AS db_import;
---------------------------
CREATE TABLE mauer_street_segments
(
 id_segment INTEGER PRIMARY KEY,
 id_street INTEGER,
 id_street_segment INTEGER,
 name TEXT DEFAULT '',
 notes TEXT DEFAULT '',
 belongs_to TEXT DEFAULT '',
 admin_level INTEGER DEFAULT 1100,
 valid_since DATE DEFAULT '0001-01-01',
 valid_until DATE DEFAULT '3000-01-01',
 street_class DEFAULT '',
 element_number DEFAULT '',
 meters_length DOUBLE  DEFAULT 0,
 intersection_type INTEGER  DEFAULT 0,
 relate_matrix TEXT DEFAULT ''
);
SELECT AddGeometryColumn('mauer_street_segments','soldner_segment',3068,'MULTILINESTRING','XY');
SELECT CreateSpatialIndex('mauer_street_segments','soldner_segment');
SELECT AddGeometryColumn('mauer_street_segments','soldner_segment_mauer',3068,'MULTILINESTRING','XY');
SELECT CreateSpatialIndex('mauer_street_segments','soldner_segment_mauer');
SELECT AddGeometryColumn('mauer_street_segments','soldner_segment_diff',3068,'MULTILINESTRING','XY');
SELECT CreateSpatialIndex('mauer_street_segments','soldner_segment_diff');
---------------
INSERT INTO mauer_street_segments (id_segment,id_street, id_street_segment, name, notes,belongs_to, admin_level,valid_since,valid_until,street_class,element_number,relate_matrix,soldner_segment, soldner_segment_mauer, intersection_type )
SELECT
 id_segment,id_street, id_street_segment, a_source.name, a_source.notes,a_source.belongs_to, a_source.admin_level,a_source.valid_since,a_source.valid_until,street_class,element_number,
ST_Relate(a_source.soldner_segment, b_source.soldner_polygon),
 CastToMultiLineString(soldner_segment),
 CastToMultiLineString(ST_Intersection(b_source.soldner_polygon, a_source.soldner_segment)) AS soldner_segment_mauer,
 CASE
  WHEN ST_Within(a_source.soldner_segment, b_source.soldner_polygon)
  THEN 1 -- Compleatly contained inside
   ELSE 
    CASE
     WHEN ST_Crosses(a_source.soldner_segment, b_source.soldner_polygon)
     THEN 2 -- Crosses into and out again
     ELSE
      CASE
       WHEN ST_Overlaps(a_source.soldner_segment, b_source.soldner_polygon)
      THEN 3 
       ELSE
        CASE
         WHEN ST_Touches(a_source.soldner_segment, b_source.soldner_polygon)
         THEN 4 -- Crosses into, but not out again
         ELSE
          CASE
           WHEN ST_Disjoint(a_source.soldner_segment, b_source.soldner_polygon)
           THEN 5
           ELSE
            CASE
             WHEN ST_Equals(a_source.soldner_segment, b_source.soldner_polygon)
             THEN 6
            END
          END
        END
      END
    END
 END AS intersection_type
FROM
 db_import.berlin_street_segments a_source,
 db_import.berlin_polygons b_source
WHERE
(
 ST_Intersects(a_source.soldner_segment, b_source.soldner_polygon)
);
---------------
UPDATE mauer_street_segments SET meters_length=ST_Length(soldner_segment_mauer) WHERE soldner_segment_mauer IS NOT NULL;
UPDATE mauer_street_segments SET soldner_segment_diff=CastToMultiLineString(ST_Difference(CastToMultiLineString(soldner_segment),soldner_segment_mauer)) WHERE soldner_segment_mauer IS NOT NULL;
SELECT
 ST_Difference(soldner_segment,soldner_segment_mauer)
FROM mauer_street_segments
WHERE id_street=1811016935;
-- SRID=3068;LINESTRING(24810.59736691505 23664.22581131355,24846.64252081577 23586.36750659061)
-- SRID=3068;MULTILINESTRING((24819.85698453766 23644.2248388537,24835.38784578578 23610.67784579615))
-- SRID=3068;MULTILINESTRING((24810.59736691505 23664.22581131355,24825.88165313041 23631.21142560983),(24825.88165313041 23631.21142560983,24846.64252081577 23586.36750659061))
---------------
-- GEOS error: TopologyException: Input geom 1 is invalid: Self-intersection at or near point 3441.0274039605292 9731.1828479805226 at 3441.0274039605292 9731.1828479805226
--  3441.0274039605292,9731.1828479805226
-- Mauer POLYGON Gelinicke Brücke
---------------
-- Contains, Covers, Crosses, Disjoint, Equals, Intersects, Touches
---------------
SELECT DateTime('now'),'DETACH DATABASE ''area_bernauer_strasse.db'' AS db_import';
DETACH DATABASE db_import;
---------------------------
---------------
SELECT DateTime('now'),'build.area_street_intersects.sql [finished] ';
---------------
