---------------
-- rm sandro_script.db ; spatialite sandro_script.db < sandro_script.sql;
---------------
SELECT DateTime('now'),'sandro_script.sql [start] ';
---------------------------
-- I started by creating several tables attempting to closely mimic your own names as far as possible: 
CREATE TABLE mauer (id INTEGER PRIMARY KEY); 
SELECT AddGeometryColumn('mauer', 'geom', -1,'POLYGON', 'XY'); 
CREATE TABLE segment (id INTEGER PRIMARY KEY); 
SELECT AddGeometryColumn('segment', 'geom', -1,'LINESTRING', 'XY'); 
CREATE TABLE segment_mauer (id INTEGER PRIMARY KEY); 
SELECT AddGeometryColumn('segment_mauer', 'geom', -1,'LINESTRING', 'XY'); 
CREATE TABLE segment_no_mauer (id INTEGER PRIMARY KEY); 
SELECT AddGeometryColumn('segment_no_mauer', 'geom', -1,'MULTILINESTRING', 'XY'); 
-- Then I've inserted a rectangle (" mauer") and a simple segment: 
INSERT INTO mauer VALUES (1, ST_GeomFromText('POLYGON((-100 10, 100 10, 100 -10,-100 -10, -100 10))', -1)); 
INSERT INTO mauer VALUES (2, ST_GeomFromText('POLYGON((24855.42499999999 23660.55912126101,24855.42499999999 23622.20170501772,24853.23123552834 23621.17648174639,24816.11152982148 23599.33610934971,24783.09377351578 23572.28180460813,24567.63925789716 23470.76158638679,24562.97783361784 23479.24330541722,24553.62749457413 23485.05039896446,24488.98635819149 23453.28553703264,24472.45259986984 23445.81983311266,24465.429 23441.00417227731,24465.429 23481.45706232085,24855.42499999999 23660.55912126101))', -1)); 
INSERT INTO segment VALUES (1, ST_GeomFromText('LINESTRING(-10 50, 10 -50)', -1));
INSERT INTO segment VALUES (2, ST_GeomFromText('LINESTRING(24636.5843357909 23582.20407505593,24672.54164340561 23505.36865267401)', -1));
INSERT INTO segment VALUES (3, ST_GeomFromText('LINESTRING(24724.52095093072 23622.39599521518,24791.25226395342 23478.21791515027)', -1));
INSERT INTO segment VALUES (4, ST_GeomFromText('LINESTRING(24810.59736691505 23664.22581131355,24846.64252081577 23586.36750659061)', -1));
-- SRID=3068;LINESTRING(24636.5843357909 23582.20407505593,24672.54164340561 23505.36865267401)
-- SRID=3068;LINESTRING(24724.52095093072 23622.39599521518,24791.25226395342 23478.21791515027)
-- SRID=3068;LINESTRING(24810.59736691505 23664.22581131355,24846.64252081577 23586.36750659061)
-- Extracting the intersection between the rectangle and the segment is simple and easy, as you already reported: 
INSERT INTO segment_mauer 
SELECT 1, ST_Intersection(mauer.geom, segment.geom) FROM mauer, segment WHERE ((segment.id=1) AND (mauer.id=1));
INSERT INTO segment_mauer 
SELECT 2, ST_Intersection(mauer.geom, segment.geom) FROM mauer, segment WHERE ((segment.id=2) AND (mauer.id=2));
-- Final step: extracting the difference between the segment and the polygon 
-- (or between the whole segment and the shortest segment I've extracted just before, 
INSERT INTO segment_no_mauer 
SELECT 1, ST_Difference(segment.geom, mauer.geom) FROM mauer, segment WHERE ((segment.id=1) AND (mauer.id=1));
-- that is the same in this specific case).
INSERT INTO segment_no_mauer 
SELECT 2, ST_Difference(segment.geom, segment_mauer.geom) FROM segment_mauer, segment WHERE ((segment.id=1) AND (segment_mauer.id=1));
INSERT INTO segment_no_mauer 
SELECT 3, ST_Difference(segment.geom, mauer.geom) FROM mauer, segment WHERE ((segment.id=2) AND (mauer.id=2));
INSERT INTO segment_no_mauer 
SELECT 4, ST_Difference(segment.geom, mauer.geom) FROM mauer, segment WHERE ((segment.id=3) AND (mauer.id=2));
INSERT INTO segment_no_mauer 
SELECT 5, ST_Difference(segment.geom, mauer.geom) FROM mauer, segment WHERE ((segment.id=4) AND (mauer.id=2));
-- Both methods return exactly the same result, and it is what we were expecting. 
-- so, where is the problem ?
---------------
SELECT DateTime('now'),'sandro_script.sql [finished] ';
---------------
